package apachetest;

import java.net.InetAddress;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;


/**
 *
 * @author Admin
 */
public class IdGenerator {

	//private static SecureRandom[] secureRandomArr = new SecureRandom[10];
	private static SecureRandom secureRandom = null;
	private static String ipAddr = "000.000.000.000";

	/**
	 * Return the last 3 digits of the Ip Address 
	 * @return int Last 3 digits of the ip address
	 */
	public static int getLastThreeDigitOfLocalIp()
	{
        int retVal = -1;
        try
        {
            if (ipAddr.equals("000.000.000.000"))
            {
                InetAddress addr;

                addr = InetAddress.getLocalHost();
                ipAddr = addr.getHostAddress();
                if (ipAddr == null)
                {
                    ipAddr = "000.000.000.000";
                }
            }

            int index = ipAddr.lastIndexOf(".");
            if (index == -1 || index + 1 >= ipAddr.length())
            {
                return -1;
            }
            retVal = Integer.parseInt(ipAddr.substring(index + 1));

        }
        catch (Exception e)
        {
            retVal = -1;
        }

        return retVal;
    }

        /**
	 * this method return the System address of host machine
	 * @return String returns the system ip address
	 */
    public static String getSystemIPAddressStr()
    {
        if (ipAddr.equals("000.000.000.000"))
        {
            InetAddress addr;
            try
            {
                addr = InetAddress.getLocalHost();
                ipAddr = addr.getHostAddress();
                if (ipAddr == null)
                {
                    ipAddr = "000.000.000.000";
                }
            }
            catch (Exception e)
            {
                e.printStackTrace();
                return "";
            }
        }
        return ipAddr;
    }
        
	/**
	 * this method return the System address of host machine
	 * @return long returns the system ip address
	 */
	public static long getSystemIPAddress() {
	    if (ipAddr.equals("000.000.000.000"))
        {
            InetAddress addr;

            try
            {
                addr = InetAddress.getLocalHost();
                ipAddr = addr.getHostAddress();
            }
            catch (Exception e)
            {
                e.printStackTrace();
                return toNumeric(ipAddr);
            }
        }
		return toNumeric(ipAddr);
	}

	/**
	 * This method convert String ip address in long.
	 * @param ipAddr String IP Address
	 * @return long ip address as long
	 */
	public static long toNumeric(String ipAddr) {
		try{
			String ipAdd = "";
			String res[] = ipAddr.replace('.', ';').split(";");
			for (int iCount = 0; iCount < res.length; iCount++) {
				res[iCount] = (res[iCount].length() < 3) ? (res[iCount].length() == 1 ? "00"
						+ res[iCount]
						      : "0" + res[iCount])
						      : res[iCount];
						ipAdd = ipAdd + res[iCount];
			}
			return Long.parseLong(ipAdd);
		}catch(Exception ex)
		{
			return 0;
		}
	}

	/**
	 * Creates and returns the unique id
	 * @param id1 Parameter for id creation
	 * @param id2 Parameter for id creation
	 * @return long Unique id
	 */
	public static long createUniqueId(int id1, int id2) {
		String sUniqueId = "" + id1 + (id2 < 10 ? "00" + id2 : (id2 < 100 ? "0" + id2 : "" + id2));
		return Long.parseLong(sUniqueId);
	}

	/**
	 * Parses the unique id and returns the 2 parts
	 * @param uniqueId Unique Id
	 * @return int Array of the constituent parts
	 */
	public static int[] parseUniqueId(long uniqueId) {
		int idArr[] = new int[2];
		idArr[1] = (int) (uniqueId % 1000);
		idArr[0] = (int) ((uniqueId - idArr[1]) / 1000);
		return idArr;
	}
	
	public static int parseLowerId(long uniqueId) {
		return  (int) (uniqueId % 1000);
	}
	
	public static int parseUpperId(long uniqueId) {
		return (int) (uniqueId - (uniqueId % 1000))/1000;
	}

	/**
	 * Generates a secure random object
	 * @return SecureRandom Generated object
	 */
	private static synchronized SecureRandom generateSecureRandom() {
		if (secureRandom!=null)
		{
			return secureRandom;
		}
		try {
			secureRandom = SecureRandom.getInstance("SHA1PRNG");
		} catch (NoSuchAlgorithmException e) {

		}
		if (secureRandom==null)
		{
			secureRandom = new SecureRandom();
		}
		secureRandom.nextBytes(new byte[8]); // seed
		return secureRandom;
	}

	/**
	 * Generates a unique id
	 * @return String Unique id
	 */
	public static String generateUniqueId() {
		int length = 8;
		if (secureRandom==null)
		{
			secureRandom = generateSecureRandom();
		}
		byte[] keyBytes = new byte[length];
		synchronized (secureRandom) {
			secureRandom.nextBytes(keyBytes);
		}
		return bytesToSessionKey(keyBytes);
	}

	/**
	 * Converts the bytes to session key
	 * @param bytes Bytes array
	 * @return String Session key
	 */
	private static String bytesToSessionKey(byte[] bytes) {
		char[] keyChars = new char[bytes.length * 2];
		for (int i = 0; i < bytes.length; ++i) {
			byte b1 = (byte) ((bytes[i] & 0xf0) >> 4);
			byte b2 = (byte) (bytes[i] & 0x0f);
			keyChars[2 * i] = toKeyStringChar(b1);
			keyChars[2 * i + 1] = toKeyStringChar(b2);
		}
		return new String(keyChars);
	}

	/**
	 * Converts the byte to char
	 * @param b Byte
	 * @return char Character for the byte
	 */
	private static final char toKeyStringChar(byte b) {
		if (b < 10) {
			return (char) ('0' + b);
		} else {
			return (char) ('A' + b - 10);
		}
	}
}
